import create from 'zustand'
import { Vector3 } from 'three'
interface MyStore {
  choose : any | undefined;
  search : string;
  count : number;
  focus : Vector3,
  update : {flag:boolean},
  fullScreen : boolean,
  muted : boolean,
  tutorial : boolean,
  tabs : number,
  setChoose: (data: any) => void;
}

const useStore = create<MyStore>((set) => ({
  choose : undefined,
  search : "",
  count : 0,
  focus : new Vector3(3, 0, 0), 
  update : {flag:false},
  fullScreen : false,
  muted : true,
  tutorial : true,
  tabs : 3, 
  setChoose : (data: any ) => set((state) => ({
    choose: data,
  }))  
}))

export default useStore